<template>
  <div>
    <q-btn-dropdown
      dense flat stretch
      class="float-left q-pa-none "
      color="primary"
      label="Actions"
      size="12px"
      icon="la la-cog"
      dropdown-icon=" "
      v-if="displayedActions.length && ((selected && selected.length !== 0) || !(dState ==='list' || dState === 'save'))">
      <q-list>
        <q-item v-for="act in displayedActions" :key="act.label" clickable v-close-popup dense
                @click="act.func('')">
          <q-item-section>
            <q-item-label caption>{{ act.label }}</q-item-label>
          </q-item-section>
        </q-item>
      </q-list>
    </q-btn-dropdown>

    <q-btn-toggle stretch
                  dense v-if="displayTableToggleButton && state === 'list'"
                  class="on-right float-right q-mr-md q-my-xs" v-model="modelDisplay"
                  size="sm" toggle-color="primary"
                  toggle-text-color="white" unelevated
                  :options="[ {value: 'grid', slot: 'one'}, {value: 'list', slot: 'two'}, ]">
      <template v-slot:one>
        <div class="items-center no-wrap">
          <q-icon name="la la-table"/>
        </div>
      </template>
      <template v-slot:two>
        <div class="items-center no-wrap">
          <q-icon name="la la-list"/>
        </div>
      </template>
    </q-btn-toggle>

    <q-btn
      v-if="showStateButton"
      color="primary" dense stretch
      size="sm" unelevated
      :label="displayStateText ? getStateButtonLabel : ''"
      :icon="getStateButtonIcon"
      @click="onStateButtonClicked"
      class="q-px-sm q-my-xs on-right float-right">
      <q-tooltip>
        {{ getStateButtonLabel }}
      </q-tooltip>
    </q-btn>
    <q-btn
      v-if="showActionButton"
      outline size="sm" stretch
      color="primary" dense
      :label="displayActionText ? getActionButtonLabel : ''"
      :icon="getActionButtonIcon"
      class="q-px-sm q-my-xs q-ml-xs float-right"
      @click="onActionButtonClicked">
      <q-tooltip>
        {{ getActionButtonLabel }}
      </q-tooltip>
    </q-btn>
  </div>
</template>

<script>

export default {
  name: 'MControlPanel',

  components: {/*MSortFilterTable*/},

  props: {
    state: {
      type: String,
      default: 'save',
    },
    actions: {
      type: Array,
    },
    //
    filterColumns: Array,
    display: {
      type: String,
      default: 'list',
    },
    selected: Array,
    canUpdate: {
      type: Boolean,
      default: true,
    },
    canCreate: {
      type: Boolean,
      default: true,
    },
    displayTableToggleButton: {
      type: Boolean,
      default: true,
    },
    stateButtonText: {
      type: String,
      default: '',
    },
    actionButtonText: {
      type: String,
      default: '',
    },
    stateButtonIcon: {
      type: String,
      default: '',
    },
    actionButtonIcon: {
      type: String,
      default: '',
    },
    pagination: {
      type: Object,
    },
    displayStateText: {
      type: Boolean,
      default: false,
    },
    displayActionText: {
      type: Boolean,
      default: false,
    },
  },

  data() {
    return {
      modelDisplay: this.display || 'list',
      disable: '',
      dSelected: this.selected,
      mPagination: this.pagination,
    }
  },

  methods: {
    onStateButtonClicked($event) {
      this.$emit('on-state-button-clicked', this.dState, $event.target.value)
    },
    onActionButtonClicked($event) {
      this.$emit('on-action-button-clicked', this.dState, $event.target.value)
    },
  },

  watch: {
    pagination: {
      handler: function (val, oldVal) {
        this.mPagination = val
      },
      deep: true,
    },
    mPagination: {
      handler: function (val, oldVal) {
        //console.warn('MCntrolPanel:mPagination watch ', this.mPagination)
        this.$emit('update:pagination', val)
      },
      deep: true,
      immediate: true,
    },
    modelDisplay(val) {
      this.$emit('update:display', val)
    },
    display(val) {
      this.modelDisplay = val
    },
    selected(val) {
      this.dSelected = val
    },
  },

  computed: {
    displayedActions() {
      return this.actions.filter(x => x.display)
    },

    showStateButton() {
      if (this.dState === 'list') {
        return this.canCreate
      }
      if (this.dState === 'view') {
        return true
      }
      if (this.dState === 'create' || this.dState === 'update') {
        return this.canUpdate
      }
      return false
    },
    getStateButtonLabel() {
      if (this.stateButtonText) {
        return this.stateButtonText
      }
      switch (this.state) {
        case 'list' :
          return 'Ajouter'
        case 'create' :
          return 'Sauvegarder'
        case 'update' :
          return 'Enregistrer'
        case 'view' :
          return 'Modifier'
      }
      return 'Non défini'
    },
    getStateButtonIcon() {
      if (this.stateButtonIcon) {
        return this.stateButtonIcon
      }
      switch (this.state) {
        case 'list' :
          return 'la la-plus'
        case 'create' :
        case 'update' :
          return 'la la-save'
        case 'view' :
          return 'la la-edit'
      }
      return 'la la-stop'
    },

    showActionButton() {
      if (this.dState === 'list') {
        return false
      }
      if (this.dState === 'view')
        return this.canCreate

      return this.dState === 'create' || this.dState === 'update';

    },
    getActionButtonLabel() {
      if (this.actionButtonText) {
        return this.actionButtonText
      }
      switch (this.dState) {
        case 'create' :
          return 'Retour'
        case 'view' :
          return 'Nouveau'
        case 'update' :
          return 'Annuler'
      }
      return 'Non défini'
    },
    getActionButtonIcon() {
      if (this.actionButtonIcon) {
        return this.actionButtonIcon
      }
      switch (this.state) {
        case 'create' :
          return 'la la-arrow-left'
        case 'view' :
          return 'la la-plus'
        case 'update' :
          return 'la la-ban'
      }
      return 'la la-stop'
    },
    dState() {
      return this.state;
    }
  },

}
</script>
<style lang="scss">
button.without-icon i {
  display: none
}
</style>
